///<summary> /// Implement this method as an external command for Revit. /// </summary> /// <param name="commandData">An object that is passed to the external application /// which contains data related to the command, /// such as the application object and active view.</param> /// <param name="message">A message that can be set by the external application /// which will be displayed if a failure or cancellation is returned by /// the external command.</param> /// <param name="elements">A set of elements to which the external application /// can add elements that are to be highlighted in case of failure or cancellation.</param> /// <returns>Return the status of the external command. /// A result of Succeeded means that the API external method functioned as expected. /// Cancelled can be used to signify that the user cancelled the external operation /// at some point. Failure should be returned if the application is unable to proceed with /// the operation.</returns> public Autodesk.Revit.UI.Result Execute(ExternalCommandData commandData, ref string message, Autodesk.Revit.DB.ElementSet elements) { try { Wall wall = null; Floor floor = null; FamilyInstance familyInstance = null; ElementSet elems = commandData.Application.ActiveUIDocument.Selection.Elements; #region selection handle -- select one floor, wall, beam or nothing //if user had some wrong selection, give user an Error message string errorMessage = "Please select one Floor (Beam or Wall) to create opening or select nothing to create Shaft Opening"; if (elems.Size > 1) { message = errorMessage; return(Autodesk.Revit.UI.Result.Cancelled); } Autodesk.Revit.DB.Element selectElem = null; if (1 == elems.Size) { IEnumerator iter = elems.GetEnumerator(); iter.Reset(); if (iter.MoveNext()) { selectElem = (Autodesk.Revit.DB.Element)iter.Current; } if (selectElem is Wall) { wall = selectElem as Wall; } else if (selectElem is Floor) { floor = selectElem as Floor; } else if (selectElem is FamilyInstance) { familyInstance = selectElem as FamilyInstance; if (familyInstance.StructuralType != Autodesk.Revit.DB.Structure.StructuralType.Beam) { message = errorMessage; return(Autodesk.Revit.UI.Result.Cancelled); } } else { message = errorMessage; return(Autodesk.Revit.UI.Result.Cancelled); } } #endregion try { if (null != wall) { ProfileWall profileWall = new ProfileWall(wall, commandData); ShaftHolePuncherForm shaftHolePuncherForm = new ShaftHolePuncherForm(profileWall); shaftHolePuncherForm.ShowDialog(); } else if (null != floor) { ProfileFloor profileFloor = new ProfileFloor(floor, commandData); ShaftHolePuncherForm shaftHolePuncherForm = new ShaftHolePuncherForm(profileFloor); shaftHolePuncherForm.ShowDialog(); } else if (null != familyInstance) { ProfileBeam profileBeam = new ProfileBeam(familyInstance, commandData); ShaftHolePuncherForm shaftHolePuncherForm = new ShaftHolePuncherForm(profileBeam); shaftHolePuncherForm.ShowDialog(); } else { ProfileNull profileNull = new ProfileNull(commandData); ShaftHolePuncherForm shaftHolePuncherForm = new ShaftHolePuncherForm(profileNull); shaftHolePuncherForm.ShowDialog(); } } catch (Exception ex) { message = ex.Message; return(Autodesk.Revit.UI.Result.Cancelled); } return(Autodesk.Revit.UI.Result.Succeeded); } catch (Exception e) { message = e.Message; return(Autodesk.Revit.UI.Result.Failed); } }
///<summary> /// Implement this method as an external command for Revit. /// </summary> /// <param name="commandData">An object that is passed to the external application /// which contains data related to the command, /// such as the application object and active view.</param> /// <param name="message">A message that can be set by the external application /// which will be displayed if a failure or cancellation is returned by /// the external command.</param> /// <param name="elements">A set of elements to which the external application /// can add elements that are to be highlighted in case of failure or cancellation.</param> /// <returns>Return the status of the external command. /// A result of Succeeded means that the API external method functioned as expected. /// Cancelled can be used to signify that the user cancelled the external operation /// at some point. Failure should be returned if the application is unable to proceed with /// the operation.</returns> public Autodesk.Revit.UI.Result Execute(ExternalCommandData commandData, ref string message, Autodesk.Revit.DB.ElementSet elements) { try { Wall wall = null; Floor floor = null; FamilyInstance familyInstance = null; ElementSet elems = commandData.Application.ActiveUIDocument.Selection.Elements; #region selection handle -- select one floor, wall, beam or nothing //if user had some wrong selection, give user an Error message string errorMessage = "Please select one Floor (Beam or Wall) to create opening or select nothing to create Shaft Opening"; if (elems.Size > 1) { message = errorMessage; return Autodesk.Revit.UI.Result.Cancelled; } Autodesk.Revit.DB.Element selectElem = null; if (1 == elems.Size) { IEnumerator iter = elems.GetEnumerator(); iter.Reset(); if (iter.MoveNext()) { selectElem = (Autodesk.Revit.DB.Element)iter.Current; } if (selectElem is Wall) { wall = selectElem as Wall; } else if (selectElem is Floor) { floor = selectElem as Floor; } else if (selectElem is FamilyInstance) { familyInstance = selectElem as FamilyInstance; if (familyInstance.StructuralType != Autodesk.Revit.DB.Structure.StructuralType.Beam) { message = errorMessage; return Autodesk.Revit.UI.Result.Cancelled; } } else { message = errorMessage; return Autodesk.Revit.UI.Result.Cancelled; } } #endregion try { if (null != wall) { ProfileWall profileWall = new ProfileWall(wall, commandData); ShaftHolePuncherForm shaftHolePuncherForm = new ShaftHolePuncherForm(profileWall); shaftHolePuncherForm.ShowDialog(); } else if (null != floor) { ProfileFloor profileFloor = new ProfileFloor(floor, commandData); ShaftHolePuncherForm shaftHolePuncherForm = new ShaftHolePuncherForm(profileFloor); shaftHolePuncherForm.ShowDialog(); } else if (null != familyInstance) { ProfileBeam profileBeam = new ProfileBeam(familyInstance, commandData); ShaftHolePuncherForm shaftHolePuncherForm = new ShaftHolePuncherForm(profileBeam); shaftHolePuncherForm.ShowDialog(); } else { ProfileNull profileNull = new ProfileNull(commandData); ShaftHolePuncherForm shaftHolePuncherForm = new ShaftHolePuncherForm(profileNull); shaftHolePuncherForm.ShowDialog(); } } catch (Exception ex) { message = ex.Message; return Autodesk.Revit.UI.Result.Cancelled; } return Autodesk.Revit.UI.Result.Succeeded; } catch (Exception e) { message = e.Message; return Autodesk.Revit.UI.Result.Failed; } }